'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = deepmerge;

/* eslint-disable no-param-reassign */

function deepmerge(target, src) {
  if (Array.isArray(src)) {
    var _dst = [];
    target = target || [];
    _dst = _dst.concat(target);
    src.forEach(function (e, i) {
      if (typeof _dst[i] === 'undefined') {
        _dst[i] = e;
      } else if (typeof e === 'object') {
        _dst[i] = deepmerge(target[i], e);
      } else if (target.indexOf(e) === -1) {
        _dst.push(e);
      }
    });
    return _dst;
  }

  var dst = {};
  if (target && typeof target === 'object') {
    Object.keys(target).forEach(function (key) {
      dst[key] = target[key];
    });
  }
  Object.keys(src).forEach(function (key) {
    if (typeof src[key] !== 'object' || !src[key]) {
      dst[key] = src[key];
    } else if (!target[key]) {
      dst[key] = src[key];
    } else {
      dst[key] = deepmerge(target[key], src[key]);
    }
  });

  return dst;
}